#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/js/tags/2/tests/bin/JS001_three_tasks.sh $ $LastChangedRevision: 10489 $

echo "setting up environment ..."
export JS_NAME=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 8)

echo "defining support functions ..."
wait_for_jobs()
{
    while [ $(jsq | sed 1,3d | egrep -c '(running|pending)') != 0 ]; do
        sleep 0.5
    done
}

for AVAILABLE_SLOTS in 1 10; do 
    echo "starting jsd with $AVAILABLE_SLOTS slots ..."
    jsd --suspend -r slots:$AVAILABLE_SLOTS &
    JSD_PID=$!
    sleep 5  #  settle time
    
    echo "submitting the real jobs ..."
    for X in 1 2 3; do 
        jss -r slots:1 "echo \"$X: starting ...\"; sleep 5; echo \"$X: ending ...\""
    done
    
    echo "waiting for jobs to complete ..."
    jsc resume
    wait_for_jobs
    
    echo "stopping jsd ..."
    jsc quit
    wait $JSD_PID
done   

echo "all done"
