#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/js/tags/2/tests/bin/JS002_environment.sh $ $LastChangedRevision: 10273 $

echo "setting up environment ..."
export JS_NAME=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 8)

echo "defining support functions ..."
wait_for_jobs()
{
    while [ $(jsq | sed 1,3d | egrep -c '(running|pending)') != 0 ]; do
        sleep 0.5
    done
}

echo "starting daemon ..."
jsd -r cpu:4,mem:1024 &
JSD_PID=$!
sleep 5  #  settle time

echo "submitting a couple of jobs that will run in parallel ..."
for JOB_ID in 1 2; do
    #  sleep 5 is there just to ensure the two jobs do actually 
    #  run in parallel and so get allocated different resources.
    jss -r cpu:2,mem:512 "env > job-$JOB_ID.out; sleep 5"
done
echo "waiting for jobs to complete ..."
wait_for_jobs

echo "examining job output ..."
egrep '(AFFINITY|LIMIT)' job-*.out | sort

echo "cleaning up ..."
jsc quit
wait $JSD_PID

echo "all done"
