#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/js/tags/2/tests/bin/JS202_job_env.sh $ $LastChangedRevision: 10744 $

echo "setting up environment ..."
export JS_NAME=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 8)

echo "defining support functions ..."
wait_for_jobs()
{
    while [ $(jsq | sed 1,3d | egrep -c '(running|pending)') != 0 ]; do
        sleep 0.5
    done
}

echo "starting jsd ..."
jsd -r cpu:4,mem:1024 &
JSD_PID=$!
sleep 5  # settle time
    
echo "submitting a job for an existent command ..."
jss -r cpu:2,mem:128 'sleep 5; env | grep JS | egrep -v "^(JS_NAME|JSD_LOCKFILE|PWD|[^=]*PREFIX)=" | sort | sed "s/JS_USER=.*/JS_USER=variant/"'

echo "waiting for job to complete ..."
wait_for_jobs

echo "cleaning up ..."
jsc quit
wait $JSD_PID

echo "all done"
