#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/js/tags/2/tests/bin/JS203_echo.sh $ $LastChangedRevision: 10273 $

echo "setting up environment ..."
export JS_NAME=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 8)

echo "defining support functions ..."
wait_for_jobs()
{
    while [ $(jsq | sed 1,3d | egrep -c '(running|pending)') != 0 ]; do
        sleep 0.5
    done
}

echo "creating useful scripts ..."
echo -e '#!/bin/bash\necho $#' > arg-counter
chmod 700 arg-counter

echo "starting jsd suspended ..."
jsd --suspend -r slots:1 &
JSD_PID=$!
sleep 5  #  settle time
    
echo "submitting echo-based jobs ..."
for CMD in $PWD/arg-counter echo; do
    #  one word
    jss -r slots:1 "$CMD \"apple banana coconut\""
    #  two words with odd spacing
    jss -r slots:1 "$CMD \"apple  banana\" \"coconut\""
    jss -r slots:1 "$CMD \"apple\" \"banana  coconut\""
    jss -r slots:1 "$CMD \" apple\" \" banana  coconut \""
    #  three words 
    jss -r slots:1 "$CMD \"apple\" \"banana\" \"coconut\""
    #  three words  with odd spacing
    jss -r slots:1 "$CMD \" apple \" \" banana \" \" coconut \""
done

echo "resuming jsd and waiting for jobs to complete ..."
jsc resume
wait_for_jobs

echo "cleaning up ..."
jsc quit
wait $JSD_PID

echo "all done"
