#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/js/tags/2/tests/bin/JS204_shell.sh $ $LastChangedRevision: 10527 $

echo "setting up environment ..."
export JS_NAME=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 8)
export JS_SHELL=something_to_allow_me_to_already_export_this_variable
SLEEP_FACTOR=10

echo "defining support functions ..."
wait_for_jobs()
{
    while [ $(jsq | sed 1,3d | egrep -c '(running|pending)') != 0 ]; do
        sleep 0.5
    done
}

for JS_SHELL in '' /bin/nonexistent /bin/bash $ADETEST_MODROOT/share/shepherd/js-shepherd-dumb; do
    #  Don't show the full path of JS_SHELL because ADETEST_MODROOT is canonicalised, which means
    #  even for user 'alexis', the path varies depending on which machine it is run on.
    echo "starting jsd with JS_SHELL=${JS_SHELL##*/} ..."
    jsd --suspend -r slots:1 &
    JSD_PID=$!
    sleep $((SLEEP_FACTOR*1))  # settle time

    echo "submitting some shell-ish jobs ..."
    for CMD in 'echo "hello  world"' 'echo "a b" | wc'; do
        jss -r slots:1 "$CMD"
    done
        
    echo "waiting for jobs to run ..."
    jsc resume
    wait_for_jobs

    echo "cleaning up ..."
    jsc quit
    wait $JSD_PID
done

echo "all done"
