#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/js/tags/2/tests/bin/JS208_shepherd_time.sh $ $LastChangedRevision: 10273 $

##  Note this error message is sent to the terminal as it is imperative the user understands the failure.
[ $(id -u) = 0 ] || { echo "${0##*/}: this test can only pass when run as root" >/dev/tty; exit 1; }

echo "setting up environment ..."
export JS_NAME=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 8)
export JS_SHELL=$ADETEST_MODROOT/share/shepherd/js-shepherd
export JS_SHEPHERD_WARNINGS_ENABLED=false     #  make js-shepherd quieter

echo "defining support functions ..."
wait_for_jobs()
{
    while [ $(jsq | sed 1,3d | egrep -c '(running|pending)') != 0 ]; do
        sleep 0.5
    done
}

echo "starting jsd suspended ..."
jsd --suspend -r time:1000000,slots:1 &
JSD_PID=$!
sleep 5  #  settle time

echo "submitting job that'll run for longer than specified time ..."
jss -r time:5,slots:1 "sleep 10"

echo "waiting for all jobs to complete ..."
jsc resume
wait_for_jobs

echo "cleaning up ..."
jsc quit
wait $JSD_PID

echo "all done"
