#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/js/tags/2/tests/bin/JS209_ranges.sh $ $LastChangedRevision: 10489 $

echo "setting up environment ..."
export JS_NAME=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 8)
SLEEP_FACTOR=10

echo "defining support functions ..."
wait_for_jobs()
{
    while [ $(jsq | sed 1,3d | egrep -c '(running|pending)') != 0 ]; do
        sleep 0.5
    done
}
find_environ_and_show_vars()
{
    echo "finding environ file of that last job ..."
    #  Append /dev/null to the list so that strings doesn't *ever*
    #  get passed nothing and try to read stdin.
    ENVIRON="$(grep -l FINDME=xxx /proc/*/environ 2>/dev/null) /dev/null"
    strings $ENVIRON | grep ^JS_SLOTS | sort
}

echo "creating useful scripts ..."

echo "starting jsd ..."
jsd -r slots:6 &
JSD_PID=$!
sleep $((SLEEP_FACTOR*1))  #  settle time
    
echo "test: range 0-1,4-5:"
echo "submitting jobs ..."
jss -r slots:2 "sleep $((SLEEP_FACTOR*1))"
jss -r slots:2 "sleep $((SLEEP_FACTOR*3))"
echo "waiting for the first of those jobs to exit ..."
sleep $((SLEEP_FACTOR*2))
#  At this point slots 0 and 1 have been released and 
#  slots 4 and 5 have never been filled. Requesting 4
#  slots should fill 0,1,4,5.
jss -r slots:4 "bash -c 'FINDME=xxx exec sleep $((SLEEP_FACTOR*2))'"
sleep $((SLEEP_FACTOR*1))  #  allow that to start
find_environ_and_show_vars
echo "waiting for jobs to complete ..."
wait_for_jobs

echo "test: range 0-1,4:"
echo "submitting jobs ..."
jss -r slots:2 "sleep $((SLEEP_FACTOR*1))"
jss -r slots:2 "sleep $((SLEEP_FACTOR*3))"
echo "waiting for the first of those jobs to exit ..."
sleep $((SLEEP_FACTOR*2))
#  At this point slots 0 and 1 have been released and 
#  slots 4 and 5 have never been filled. Requesting 3
#  slots should fill 0,1,4.
jss -r slots:3 "bash -c 'FINDME=xxx exec sleep $((SLEEP_FACTOR*2))'"
sleep $((SLEEP_FACTOR*1))  #  allow that to start
find_environ_and_show_vars
echo "waiting for jobs to complete ..."
wait_for_jobs

echo "test: range 0,4-5:"
echo "submitting jobs ..."
jss -r slots:1 "sleep $((SLEEP_FACTOR*1))"
jss -r slots:3 "sleep $((SLEEP_FACTOR*3))"
echo "waiting for the first of those jobs to exit ..."
sleep $((SLEEP_FACTOR*2))
#  At this point slot 0 has been released and 
#  slots 4 and 5 have never been filled.
jss -r slots:3 "bash -c 'FINDME=xxx exec sleep $((SLEEP_FACTOR*2))'"
sleep $((SLEEP_FACTOR*1))  #  allow that to start
find_environ_and_show_vars
echo "waiting for jobs to complete ..."
wait_for_jobs

echo "test: range 1,3,5:"
echo "submitting jobs ..."
jss -r slots:1 "sleep $((SLEEP_FACTOR*8))"
jss -r slots:1 "sleep $((SLEEP_FACTOR*4))"
jss -r slots:1 "sleep $((SLEEP_FACTOR*8))"
jss -r slots:1 "sleep $((SLEEP_FACTOR*4))"
jss -r slots:1 "sleep $((SLEEP_FACTOR*8))"
jss -r slots:1 "sleep $((SLEEP_FACTOR*4))"
echo "waiting for the first of those jobs to exit ..."
sleep $((SLEEP_FACTOR*6))
#  At this point slots 1, 3 and 5, have been released 
#  and slots 0, 2 and 4 remain occupied.
jss -r slots:3 "bash -c 'FINDME=xxx exec sleep $((SLEEP_FACTOR*4))'"
sleep $((SLEEP_FACTOR*1))  #  allow that to start
find_environ_and_show_vars
echo "waiting for jobs to complete ..."
wait_for_jobs

echo "cleaning up ..."
jsc quit
wait $JSD_PID

echo "all done"
