##!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/js/tags/2/tests/bin/JS900_WP177_priorities.sh $ $LastChangedRevision: 10744 $

echo "setting up environment ..."
export JS_NAME=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 8)
SLEEP_FACTOR=10

echo "defining support functions ..."
submit_jobs()
{
    for I in {1..10}; do
        if ((I%2==0)); then
            jss -r slots:1 'echo high'
        else
            jss -r slots:1 'echo low'
        fi
    done
}

wait_for_jobs()
{
    while [ $(jsq | sed 1,3d | egrep -c '(running|pending)') != 0 ]; do
        sleep 0.5
    done
}

echo "starting jsd ..."
#  By using only one slot, we avoid multiplexed output.
jsd --resources=slots:1 &
JSD_PID=$!
sleep $((SLEEP_FACTOR*1))  #  settle time

echo "submitting some jobs ..."
jsc suspend
submit_jobs
jsc resume
wait_for_jobs

echo "doing the same but bumping priorities ..."
jsc suspend
submit_jobs
for J in 12 14 16 18 20; do
    jsc chprio-job $J 1
done
jsc resume
wait_for_jobs

echo "cleaning up ..."
jsc quit
wait $JSD_PID

echo "all done"
